---
title: llarp::sys::SVC_Manager

---

# llarp::sys::SVC_Manager





Inherits from [llarp::sys::I_SystemLayerManager](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[SVC_Manager](Classes/classllarp_1_1sys_1_1SVC__Manager.md#function-svc-manager)**() |
| virtual void | **[system_changed_our_state](Classes/classllarp_1_1sys_1_1SVC__Manager.md#function-system-changed-our-state)**(ServiceState st) override<br>system told us to enter this state  |
| virtual void | **[report_changed_state](Classes/classllarp_1_1sys_1_1SVC__Manager.md#function-report-changed-state)**() override<br>report our current state to the system layer  |
| virtual void | **[we_changed_our_state](Classes/classllarp_1_1sys_1_1SVC__Manager.md#function-we-changed-our-state)**(ServiceState st) override<br>change our state and report it to the system layer  |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| SERVICE_STATUS_HANDLE | **[handle](Classes/classllarp_1_1sys_1_1SVC__Manager.md#variable-handle)**  |
| constexpr auto | **[StartupTimeout](Classes/classllarp_1_1sys_1_1SVC__Manager.md#variable-startuptimeout)**  |
| constexpr auto | **[StopTimeout](Classes/classllarp_1_1sys_1_1SVC__Manager.md#variable-stoptimeout)**  |

## Additional inherited members

**Public Functions inherited from [llarp::sys::I_SystemLayerManager](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~I_SystemLayerManager](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-~i-systemlayermanager)**() =default |
| void | **[disable](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-disable)**()<br>disable all reporting to system layer  |
| void | **[give_context](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-give-context)**(llarp::Context * ctx)<br>give our current lokinet context to the system layer manager  |
| virtual void | **[report_periodic_stats](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-report-periodic-stats)**()<br>report our stats on each timer tick  |
| void | **[starting](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-starting)**() |
| void | **[ready](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-ready)**() |
| void | **[stopping](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-stopping)**() |
| void | **[stopped](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-stopped)**() |
| void | **[failed](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-failed)**() |

**Protected Attributes inherited from [llarp::sys::I_SystemLayerManager](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md)**

|                | Name           |
| -------------- | -------------- |
| bool | **[m_disable](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#variable-m-disable)**  |
| llarp::Context * | **[m_Context](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#variable-m-context)**  |


## Public Functions Documentation

### function SVC_Manager

```cpp
SVC_Manager()
```


### function system_changed_our_state

```cpp
virtual void system_changed_our_state(
    ServiceState st
) override
```

system told us to enter this state 

**Reimplements**: [llarp::sys::I_SystemLayerManager::system_changed_our_state](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-system-changed-our-state)


### function report_changed_state

```cpp
virtual void report_changed_state() override
```

report our current state to the system layer 

**Reimplements**: [llarp::sys::I_SystemLayerManager::report_changed_state](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-report-changed-state)


### function we_changed_our_state

```cpp
virtual void we_changed_our_state(
    ServiceState st
) override
```

change our state and report it to the system layer 

**Reimplements**: [llarp::sys::I_SystemLayerManager::we_changed_our_state](Classes/classllarp_1_1sys_1_1I__SystemLayerManager.md#function-we-changed-our-state)


## Public Attributes Documentation

### variable handle

```cpp
SERVICE_STATUS_HANDLE handle;
```


### variable StartupTimeout

```cpp
static constexpr auto StartupTimeout = 17s;
```


### variable StopTimeout

```cpp
static constexpr auto StopTimeout = 5s;
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000