---
title: llarp::RelayUpstreamMessage

---

# llarp::RelayUpstreamMessage





Inherits from [llarp::ILinkMessage](Classes/structllarp_1_1ILinkMessage.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual bool | **[DecodeKey](Classes/structllarp_1_1RelayUpstreamMessage.md#function-decodekey)**(const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & key, [llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) override |
| virtual bool | **[BEncode](Classes/structllarp_1_1RelayUpstreamMessage.md#function-bencode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) const override |
| virtual bool | **[HandleMessage](Classes/structllarp_1_1RelayUpstreamMessage.md#function-handlemessage)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) * router) const override |
| virtual void | **[Clear](Classes/structllarp_1_1RelayUpstreamMessage.md#function-clear)**() override |
| virtual const char * | **[Name](Classes/structllarp_1_1RelayUpstreamMessage.md#function-name)**() const override |
| virtual uint16_t | **[Priority](Classes/structllarp_1_1RelayUpstreamMessage.md#function-priority)**() const override<br>get message prority, higher value means more important  |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [Encrypted](Classes/structllarp_1_1Encrypted.md)< MAX_LINK_MSG_SIZE - 128 > | **[X](Classes/structllarp_1_1RelayUpstreamMessage.md#variable-x)**  |
| [TunnelNonce](Classes/structllarp_1_1AlignedBuffer.md) | **[Y](Classes/structllarp_1_1RelayUpstreamMessage.md#variable-y)**  |

## Additional inherited members

**Public Functions inherited from [llarp::ILinkMessage](Classes/structllarp_1_1ILinkMessage.md)**

|                | Name           |
| -------------- | -------------- |
| | **[ILinkMessage](Classes/structllarp_1_1ILinkMessage.md#function-ilinkmessage)**() =default |
| virtual | **[~ILinkMessage](Classes/structllarp_1_1ILinkMessage.md#function-~ilinkmessage)**() =default |
| bool | **[BDecode](Classes/structllarp_1_1ILinkMessage.md#function-bdecode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) |

**Public Attributes inherited from [llarp::ILinkMessage](Classes/structllarp_1_1ILinkMessage.md)**

|                | Name           |
| -------------- | -------------- |
| [ILinkSession](Classes/structllarp_1_1ILinkSession.md) * | **[session](Classes/structllarp_1_1ILinkMessage.md#variable-session)** <br>who did this message come from or is going to  |
| uint64_t | **[version](Classes/structllarp_1_1ILinkMessage.md#variable-version)**  |
| [PathID_t](Classes/structllarp_1_1PathID__t.md) | **[pathid](Classes/structllarp_1_1ILinkMessage.md#variable-pathid)**  |


## Public Functions Documentation

### function DecodeKey

```cpp
virtual bool DecodeKey(
    const llarp_buffer_t & key,
    llarp_buffer_t * buf
) override
```


**Reimplements**: [llarp::ILinkMessage::DecodeKey](Classes/structllarp_1_1ILinkMessage.md#function-decodekey)


### function BEncode

```cpp
virtual bool BEncode(
    llarp_buffer_t * buf
) const override
```


**Reimplements**: [llarp::ILinkMessage::BEncode](Classes/structllarp_1_1ILinkMessage.md#function-bencode)


### function HandleMessage

```cpp
virtual bool HandleMessage(
    AbstractRouter * router
) const override
```


**Reimplements**: [llarp::ILinkMessage::HandleMessage](Classes/structllarp_1_1ILinkMessage.md#function-handlemessage)


### function Clear

```cpp
virtual void Clear() override
```


**Reimplements**: [llarp::ILinkMessage::Clear](Classes/structllarp_1_1ILinkMessage.md#function-clear)


### function Name

```cpp
inline virtual const char * Name() const override
```


**Reimplements**: [llarp::ILinkMessage::Name](Classes/structllarp_1_1ILinkMessage.md#function-name)


### function Priority

```cpp
inline virtual uint16_t Priority() const override
```

get message prority, higher value means more important 

**Reimplements**: [llarp::ILinkMessage::Priority](Classes/structllarp_1_1ILinkMessage.md#function-priority)


## Public Attributes Documentation

### variable X

```cpp
Encrypted< MAX_LINK_MSG_SIZE - 128 > X;
```


### variable Y

```cpp
TunnelNonce Y;
```


-------------------------------

Updated on 2023-01-09 at 18:23:48 +0000