---
title: llarp/dht/explorenetworkjob.hpp

---

# llarp/dht/explorenetworkjob.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dht](Namespaces/namespacellarp_1_1dht.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::dht::ExploreNetworkJob](Classes/structllarp_1_1dht_1_1ExploreNetworkJob.md)**  |




## Source code

```cpp
#ifndef LLARP_DHT_EXPLORENETWORKJOB
#define LLARP_DHT_EXPLORENETWORKJOB

#include "tx.hpp"
#include <llarp/router_id.hpp>

namespace llarp
{
  namespace dht
  {
    struct ExploreNetworkJob : public TX<RouterID, RouterID>
    {
      ExploreNetworkJob(const RouterID& peer, AbstractContext* ctx)
          : TX<RouterID, RouterID>(TXOwner{}, peer, ctx)
      {}

      bool
      Validate(const RouterID&) const override
      {
        // TODO: check with lokid
        return true;
      }

      void
      Start(const TXOwner& peer) override;

      void
      SendReply() override;
    };
  }  // namespace dht
}  // namespace llarp

#endif
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
