---
title: llarp/dht/localrouterlookup.hpp

---

# llarp/dht/localrouterlookup.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dht](Namespaces/namespacellarp_1_1dht.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::dht::LocalRouterLookup](Classes/structllarp_1_1dht_1_1LocalRouterLookup.md)**  |




## Source code

```cpp
#ifndef LLARP_DHT_LOCALROUTERLOOKUP
#define LLARP_DHT_LOCALROUTERLOOKUP

#include "recursiverouterlookup.hpp"

#include <llarp/path/path_types.hpp>
#include <llarp/router_contact.hpp>
#include <llarp/router_id.hpp>

namespace llarp
{
  namespace dht
  {
    struct LocalRouterLookup : public RecursiveRouterLookup
    {
      PathID_t localPath;

      LocalRouterLookup(
          const PathID_t& path, uint64_t txid, const RouterID& target, AbstractContext* ctx);

      void
      SendReply() override;
    };
  }  // namespace dht
}  // namespace llarp

#endif
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
