---
title: llarp/dht/localserviceaddresslookup.hpp

---

# llarp/dht/localserviceaddresslookup.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dht](Namespaces/namespacellarp_1_1dht.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::dht::LocalServiceAddressLookup](Classes/structllarp_1_1dht_1_1LocalServiceAddressLookup.md)**  |




## Source code

```cpp
#ifndef LLARP_DHT_LOCALSERVICEADDRESSLOOKUP
#define LLARP_DHT_LOCALSERVICEADDRESSLOOKUP

#include "serviceaddresslookup.hpp"

#include <llarp/path/path_types.hpp>

namespace llarp
{
  namespace dht
  {
    struct LocalServiceAddressLookup : public ServiceAddressLookup
    {
      PathID_t localPath;

      LocalServiceAddressLookup(
          const PathID_t& pathid,
          uint64_t txid,
          uint64_t relayOrder,
          const Key_t& addr,
          AbstractContext* ctx,
          [[maybe_unused]] const Key_t& askpeer);

      void
      SendReply() override;
    };

  }  // namespace dht
}  // namespace llarp

#endif
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
