---
title: llarp/routing/path_latency_message.hpp

---

# llarp/routing/path_latency_message.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::routing](Namespaces/namespacellarp_1_1routing.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::routing::PathLatencyMessage](Classes/structllarp_1_1routing_1_1PathLatencyMessage.md)**  |




## Source code

```cpp
#pragma once

#include "message.hpp"

namespace llarp
{
  namespace routing
  {
    struct PathLatencyMessage final : public IMessage
    {
      uint64_t T = 0;
      uint64_t L = 0;
      PathLatencyMessage();

      bool
      BEncode(llarp_buffer_t* buf) const override;

      bool
      DecodeKey(const llarp_buffer_t& key, llarp_buffer_t* val) override;

      void
      Clear() override
      {
        T = 0;
        L = 0;
        version = 0;
      }

      bool
      HandleMessage(IMessageHandler* h, AbstractRouter* r) const override;
    };
  }  // namespace routing
}  // namespace llarp
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
