---
title: llarp/path/path_types.hpp

---

# llarp/path/path_types.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[std](Namespaces/namespacestd.md)** <br>STL namespace.  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::PathID_t](Classes/structllarp_1_1PathID__t.md)**  |
| struct | **[std::hash< llarp::PathID_t >](Classes/structstd_1_1hash_3_01llarp_1_1PathID__t_01_4.md)**  |




## Source code

```cpp
#pragma once

#include <llarp/crypto/constants.hpp>
#include <llarp/util/aligned.hpp>

namespace llarp
{
  struct PathID_t final : public AlignedBuffer<PATHIDSIZE>
  {
    using AlignedBuffer<PATHIDSIZE>::AlignedBuffer;
  };

}  // namespace llarp

namespace std
{
  template <>
  struct hash<llarp::PathID_t> : hash<llarp::AlignedBuffer<llarp::PathID_t::SIZE>>
  {};
}  // namespace std
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
