---
title: llarp/dns/sd_platform.hpp

---

# llarp/dns/sd_platform.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::dns](Namespaces/namespacellarp_1_1dns.md)**  |
| **[llarp::dns::sd](Namespaces/namespacellarp_1_1dns_1_1sd.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::dns::sd::Platform](Classes/classllarp_1_1dns_1_1sd_1_1Platform.md)** <br>a dns platform that sets dns via systemd resolved  |




## Source code

```cpp
#pragma once
#include "platform.hpp"

#include <llarp/constants/platform.hpp>
#include <type_traits>

namespace llarp::dns
{
  namespace sd
  {
    class Platform : public I_Platform
    {
     public:
      virtual ~Platform() = default;

      void
      set_resolver(unsigned int if_index, llarp::SockAddr dns, bool global) override;
    };
  }  // namespace sd
  using SD_Platform_t =
      std::conditional_t<llarp::platform::has_systemd, sd::Platform, Null_Platform>;
}  // namespace llarp::dns
```


-------------------------------

Updated on 2023-01-09 at 18:23:49 +0000
